<!DOCTYPE html>
<html lang="en">

<head>
    <title>document</title>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container jumbotron ">
        <h1 class="mb-4  text-center">Chi Tiết User</h1>
        <div class="row mb-3">
            <div class="col-sm-2">
                <label for="">Name: </label>
            </div>
            <div class="col-sm-10">
                <input id="inp-name" class="form-control" type="text">
            </div>
        </div>
        <div class="row mb-3">
            <div class="col-sm-2">
                <label for="">User Name: </label>
            </div>
            <div class="col-sm-10">
                <input id="user-name" class="form-control" type="text">
            </div>
        </div>
        <div class="row mb-3">
            <div class="col-sm-2">
                <label for="">Email: </label>
            </div>
            <div class="col-sm-10">
                <input id="ipn-email" class="form-control" type="text">
            </div>
        </div>

        <div class="row mb-3">
            <div class="col-sm-2">
                <label for="">Address: </label>
            </div>
            <div class="col-sm-2">
                <label for="">Suite:</label>
            </div>
            <div class="col-sm-8">
                <input id="ipn-suite" class="form-control" type="text">
            </div>
        </div>
        <div class="row mb-3">
            <div class="col-sm-2">
                <label for=""> </label>
            </div>
            <div class="col-sm-2">
                <label for="">Street:</label>
            </div>
            <div class="col-sm-8">
                <input id="ipn-street" class="form-control" type="text">
            </div>
        </div>
        <div class="row mb-3">
            <div class="col-sm-2">
                <label for=""> </label>
            </div>
            <div class="col-sm-2">
                <label for="">City:</label>
            </div>
            <div class="col-sm-8">
                <input id="ipn-city" class="form-control" type="text">
            </div>
        </div>
        <div class="row mb-3">
            <div class="col-sm-2">
                <label for=""> </label>
            </div>
            <div class="col-sm-2">
                <label for="">Zip code:</label>
            </div>
            <div class="col-sm-8">
                <input id="ipn-zip-code" class="form-control" type="text">
            </div>
        </div>
        <div class="row mb-3">
            <div class="col-sm-2">
                <label for=""> </label>
            </div>
            <div class="col-sm-2">
                <label for="">Geo:</label>
            </div>
            <div class="col-sm-2">
                <label for="">lat:</label>
            </div>
            <div class="col-sm-6">
                <input id="ipn-lat" class="form-control" type="text">
            </div>
        </div>
        <div class="row mb-3">

            <div class="col-sm-4">
                <label for=""></label>
            </div>
            <div class="col-sm-2">
                <label for="">ing:</label>
            </div>
            <div class="col-sm-6">
                <input id="ipn-ing" class="form-control" type="text">
            </div>
        </div>

        <div class="row mb-3">
            <div class="col-sm-2">
                <label for="">Phone: </label>
            </div>
            <div class="col-sm-10">
                <input id="ipn-phone" class="form-control" type="text">
            </div>
        </div>
        <div class="row mb-3">
            <div class="col-sm-2">
                <label for="">Website: </label>
            </div>
            <div class="col-sm-10">
                <input id="website" class="form-control" type="text">
            </div>
        </div>
        <div class="row mb-3">
            <div class="col-sm-2">
                <label for="">Company: </label>
            </div>
            <div class="col-sm-2">
                <label for="">Name:</label>
            </div>
            <div class="col-sm-8">
                <input id="inp-company" class="form-control" type="text">
            </div>
        </div>
        <div class="row mb-3">
            <div class="col-sm-2">
                <label for=""> </label>
            </div>
            <div class="col-sm-2">
                <label for="">Catch:</label>
            </div>
            <div class="col-sm-8">
                <input id="inp-catch" class="form-control" type="text">
            </div>
        </div>
        <div class="row mb-3">
            <div class="col-sm-2">
                <label for=""> </label>
            </div>
            <div class="col-sm-2">
                <label for="">bs:</label>
            </div>
            <div class="col-sm-8">
                <input id="inp-bs" class="form-control" type="text">
            </div>
        </div>
        <div class="row">
            <div class="col-sm-2">
                <!-- đổi tên nút quay lại thành hủy  -->
                <button id="btn-quay-lai" class="btn btn-warning form-control "> Hủy</button>
            </div>
            <div class="col-sm-8"></div>
            <div class="col-sm-2">
                <button id="btn-update" class="btn btn-success form-control">Update</button>
            </div>

        </div>
    </div>

</body>
<script>
    "use strict"

    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
        // khai báo nút quay lại 
        $("#btn-quay-lai").click(onQuayLai);
        $("#btn-update").click(onUpdateClick)
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        "use strict"
        console.log("đã load xong thẻ body ");
        var vObjectId = {
            id: ""
        }
        // b1 thu thập dữ liệu 
        readData(vObjectId);
        // b2 kiểm tra dữ liệu 
        var vResult = getValidateData(vObjectId);
        if (vResult) {
            // b3 gọi  api
            getCallApi(vObjectId);
        }
        // b4 load dữ liệu ra form 
        console.log(vObjectId);
    }
    // ấn nút update
    function onUpdateClick() {
        console.log("đã ấn nút update ");
        // xử lý 4 bước 
        // b1 thu thập dữ liệu 

        var vObjectDataUser = getReadData();
        // bước 2 validate data 
        var vResult = getValidateDataUpdate(vObjectDataUser);
        // b3 call api in server 
        if (vResult) {
            getCallApiUserUpdate(vObjectDataUser);


        }
        // hiển thị thông tin update;
        console.log("%c data", "color:red", vObjectDataUser);


    }
    // ấn nút quay lại 
    function onQuayLai() {
        console.log("đã ấn nút quay lại ");
        window.location.href = "35.10-LoadAllUsers.html";
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // ........................xử lý onpage load ding.................
    // b1 thu  thập dữ liệu 
    function readData(paramObject) {
        var vStringUrl = window.location.href;
        var vUrl = new URL(vStringUrl);
        var vId = vUrl.searchParams.get("id");
        console.log(vId);
        // bỏ qua dòng này nếu xảy ra lỗi;
        try {
            paramObject.id = vId;
        }
        catch (paramError) {
            console.log("%c lỗi bắt được  là :" + paramError, "color:red");
        }

        return vId;
    }
    // b2 kiểm tra id có tồn tại hay không
    function getValidateData(paramObject) {
        if (isNaN(paramObject.id)) {
            console.log("id không phải là số ");
            return false;
        }
        if (paramObject.id == "") {
            console.log("id là null ");
            return false;
        }
        return true;
    }
    // b3 gọi server 
    function getCallApi(paramObject) {
        const vBASE_URL = "https://jsonplaceholder.typicode.com/users/";

        $.ajax({
            url: vBASE_URL + "/" + paramObject.id,
            type: "GET",
            dataType: "json",
            success: loadDataForm,
            error: function (param) {
                console.log(param.status);
            }
        });
    }
    // b4 đổ dữ liêuh lên form
    function loadDataForm(paramObject) {
        console.log(paramObject);
        $("#inp-name").val(paramObject.name);
        $("#user-name").val(paramObject.username);
        $("#ipn-email").val(paramObject.email);
        $("#ipn-suite").val(paramObject.address.suite);
        $("#ipn-street").val(paramObject.address.street);
        $("#ipn-city").val(paramObject.address.city);
        $("#ipn-zip-code").val(paramObject.address.zipcode);
        $("#ipn-lat").val(paramObject.address.geo.lat);
        $("#ipn-ing").val(paramObject.address.geo.lng);
        $("#ipn-phone").val(paramObject.phone);
        $("#website").val(paramObject.website);
        $("#inp-company").val(paramObject.company.name);
        $("#inp-catch").val(paramObject.company.catchPhrase);
        $("#inp-bs").val(paramObject.company.bs);
    }
    // .......................xử lý nút update............................................
    // bước 1 đọc dữ liệu (read data)
    function getReadData() {
        // mẫu object cần thu thập 
        var vObjectRequestData = {
            id: "",
            name: "",
            username: "",
            email: "",
            address: {
                street: "",
                suite: "",
                city: "",
                zipcode: "",
                geo: {
                    lat: "",
                    lng: ""
                }
            },
            phone: "",
            website: "",
            company: {
                name: "",
                catchPhrase: "",
                bs: ""
            }
        };
        //   gán data vào object 
        vObjectRequestData.name = $("#inp-name").val().trim();
        vObjectRequestData.username = $("#user-name").val().trim();
        vObjectRequestData.email = $("#ipn-email").val().trim();
        vObjectRequestData.address.suite = $("#ipn-suite").val().trim();
        vObjectRequestData.address.street = $("#ipn-street").val().trim();
        vObjectRequestData.address.city = $("#ipn-city").val().trim();
        vObjectRequestData.address.zipcode = $("#ipn-zip-code").val().trim();
        vObjectRequestData.address.geo.lat = $("#ipn-lat").val().trim();
        vObjectRequestData.address.geo.lng = $("#ipn-ing").val().trim();
        vObjectRequestData.phone = $("#ipn-phone").val().trim();
        vObjectRequestData.website = $("#website").val().trim();
        vObjectRequestData.company.name = $("#inp-company").val().trim();
        vObjectRequestData.company.catchPhrase = $("#inp-catch").val().trim();
        vObjectRequestData.company.bs = $("#inp-bs").val().trim();
        var vId = readData();
        vObjectRequestData.id = vId;
        return vObjectRequestData;
    }
    // b2 validate data nút update // thông báo nếu bỏ trống trường dữ liệu 
    function getValidateDataUpdate(paramObject) {
        if (paramObject.name == "") {
            alert("please enter name");
            return false;
        }
        if (paramObject.username == "") {
            alert("please enter user name");
            return false;
        }
        if (paramObject.email == "") {
            alert("please enter email");
            return false;
        }
        if (paramObject.address.suite == "") {
            alert("please enter suite");
            return false;
        }
        if (paramObject.address.street == "") {
            alert("please enter street");
            return false;
        }

        if (paramObject.address.city == "") {
            alert("please enter city");
            return false;
        }
        if (paramObject.address.zipcode == "") {
            alert("please enter zip code");
            return false;
        }
        if (paramObject.address.geo.lat == "") {
            alert("please enter lat");
            return false;
        }
        if (paramObject.address.geo.lng == "") {
            alert("please enter lng");
            return false;
        }
        if (paramObject.phone == "") {
            alert("please enter phone");
            return false;
        }
        if (paramObject.website == "") {
            alert("please enter website");
            return false;
        }
        if (paramObject.company.name == "") {
            alert("please enter company");
            return false;
        }
        if (paramObject.company.catchPhrase == "") {
            alert("please enter catchPhrase");
            return false;
        }
        if (paramObject.company.bs == "") {
            alert("please enter company bs");
            return false;
        }
        if (paramObject.id == "" & isNaN(paramObject.id)) {
            alert("please enter id");
            return false;
        }
        return true;
    }
    // b3 gọi server update object 
    function getCallApiUserUpdate(paramObject){
        
        const vBASE_URL = "https://jsonplaceholder.typicode.com/users/";
        $.ajax({
            url: vBASE_URL + paramObject.id,
            contentType: 'application/json',
            data: JSON.stringify(paramObject),
            type: "PUT",
            success: function(paramRes){
                console.log("res update trả về :",paramRes);
                window.location.href = "35.10-LoadAllUsers.html";
            },
            error: function(paramError){
                console.log(paramError.status);
            }
        });
    }
</script>

</html>